<template>
    <div class="chart-view" v-if="state !== 'hidden'">
        <b-alert show="true" variant="danger" v-if="state === 'error'">
            <p>Error: {{ error.message }}</p>
        </b-alert>

        <div v-if="state === 'loading'" class="d-flex justify-content-center mb-3">
            <b-spinner label="Loading..."></b-spinner>
        </div>

        <b-card v-show="state === 'success'">
            <b-card-body class="d-flex justify-content-center">
                <img class="chart-image" v-bind:src="chart.png" v-if="chart.format === 'png'" alt="chart"/>

                <b-container v-if="chart.format === 'html'" class="d-flex justify-content-center full-w">
                    <b-button download="chart.html" ref="htmlBox" v-bind:href="chart.html">Download HTML file</b-button>
                </b-container>

                <b-container class="d-flex justify-content-center full-w" ref="svgBox"
                             v-if="chart.format === 'svg'">
                    <span v-html="chart.svg"></span>
                </b-container>
            </b-card-body>
        </b-card>
    </div>
</template>

<style>
.full-w {
    width: 100%;
}
</style>

<script>
    export default {
        name: "ChartView",
        data() {
            return {
                states: ['hidden', 'loading', 'error', 'success'],
                state: 'hidden',
                chart: {
                    format: '',
                    png: '',
                    html: '',
                    svg: ''
                },
                error: {
                    message: ''
                }
            }
        },
        methods: {
            displayChartFromPNGBase64(input) {
                this.$data.state = "success";
                this.$data.chart.format = 'png';
                this.$data.chart.png = input.data;
            },
            displayChartFromSVG(input) {
                this.$data.state = "success";
                this.$data.chart.format = 'svg';
                this.$data.chart.svg = input.data;
                this.$forceUpdate();
                this.$refs.svgBox.innerHTML = this.$data.chart.svg;
            },
            displayChartFromHTML(input) {
                this.$data.state = "success";
                this.$data.chart.format = 'html';
                this.$data.chart.html = input.data;
            }
        }
    }
</script>

<style scoped>
.chart-view {
    padding-top: 30px;
    padding-bottom: 30px;
}
</style>